<template>
  <section class="room-page two-col-page container">
    <thumb-slider v-if="isMobileSSR && room.images"
                  :slider-items="room.images"
                  class="room-page__mobile-slider"
    >
      <!--<template v-slot:badges>-->
        <!--<span class="room-page__badge room-page__badge&#45;&#45;popular">Популярное</span>-->
        <!--<span class="room-page__badge room-page__badge&#45;&#45;confirm">-->
          <!--<icon-check/>-->
        <!--</span>-->
      <!--</template>-->
    </thumb-slider>

    <div class="two-col-page__content">
      <thumb-slider v-if="!isMobileSSR && room.images"
                    :slider-items="room.images" >
        <!--<template v-slot:badges>-->
          <!--<span class="room-page__badge room-page__badge&#45;&#45;popular">Популярное</span>-->
          <!--<span class="room-page__badge room-page__badge&#45;&#45;confirm">-->
            <!--<icon-check/>-->
          <!--</span>-->
        <!--</template>-->
      </thumb-slider>

      <schedule-with-calendar
        id="schedule"
        ref="schedule"
        v-if="room.schedule"
        :room="room"
        :mobileToTop="mobileToTop"
      />

      <room-description :description="description"
                        @mobileToTop="mobileToTop"
                        class="room-page__description"
                        ref="description"
                        :shortDescription="room.description_short ? room.description_short : ''"
                        :longDescription="room.description_full ? room.description_full : ''"
                        :schedule="room.schedule"
                        id="description"
      />

      <room-map class="room-page__map"
                v-if="room.gps_coords"
                :coords="[room.gps_coords.lat, room.gps_coords.lng]"
                :address="room.address || ''"
                @mobileToTop="mobileToTop"
                ref="map"
                id="map"
      />

      <pre-footer v-if="meta.content"
                  :content="meta.content"/>
    </div>

    <div class="two-col-page__right room-page__right"
         ref="roomNav"
    >
      <div class="room-page__breadcrumbs">
        <nuxt-link to="/" class="room-page__breadcrumbs-item">Главная</nuxt-link>
        <nuxt-link to="/places" class="room-page__breadcrumbs-item">Помещения</nuxt-link>
      </div>

      <h3 class="room-page__title">{{ wrappedRoomName }}</h3>

      <div class="room-page__info-wrapper">
        <div class="room-page__info">
          <span class="room-page__info-item"
                v-if="room.area">{{ room.area }} м2</span>

          <span class="room-page__info-item"
                v-if="room.capacity">до {{ room.capacity }} человек</span>

          <span class="room-page__info-item"
                v-if="room.metro_station">Метро {{ room.metro_stations[0].name }}</span>

          <span class="room-page__info-item"
                v-if="room.address">{{ room.address }}</span>

          <span class="room-page__info-item"
                v-if="room.floor">{{ room.floor }} этаж</span>
        </div>
      </div>

      <span class="room-page__price"
            v-if="bookingsPrice">
        {{ bookingsPrice | rubCurrency}}
      </span>

      <span class="room-page__price"
            v-else>
        от {{ room.price | rubCurrency}}
      </span>


      <nuxt-link :to="{ path: '/login', query: {place: room.id}} "
                 v-if="!isAuthenticated"
                 class="room-page__book-btn button button--green">
        Забронировать
      </nuxt-link>

      <template v-else>
        <nuxt-link :to="`/checkout/${room.id}`"
                   v-if="bookingItems.length"
                   class="room-page__book-btn button button--green">
          Забронировать
        </nuxt-link>
        <button v-else
                @click="addScheduleRow"
                class="room-page__book-btn button button--green">
          Забронировать
        </button>
      </template>


      <nuxt-link to="/rules" class="room-page__rules-btn">Как это работает?</nuxt-link>

      <ul class="room-page__nav">
        <li class="room-page__nav-item"
            :class="{'active': activeScrollSection === 'schedule'}"
            @click="setActive('schedule')"
        >
          <a href="javascript:void(0)" class="room-page__nav-link">
            <icon-time class="room-page__nav-icon"></icon-time>
          </a>
        </li>
        <li class="room-page__nav-item"
            :class="{'active': activeScrollSection === 'description'}"
            @click="setActive('description')"
        >
          <a href="javascript:void(0)" class="room-page__nav-link">
            <icon-burger class="room-page__nav-icon"></icon-burger>
          </a>
        </li>
        <li class="room-page__nav-item"
            :class="{'active': activeScrollSection === 'map'}"
            @click="setActive('map')"
        >
          <a href="javascript:void(0)" class="room-page__nav-link">
            <icon-map-pin class="room-page__nav-icon"></icon-map-pin>
          </a>
        </li>
      </ul>
    </div>

  </section>
</template>

<script>
  import _ from 'lodash';
  import { mapGetters } from 'vuex';

  import IconTime from '../../components/icons/IconTime';
  import IconBurger from '../../components/icons/IconBurger';
  import IconMapPin from '../../components/icons/IconMapPin';
  import IconSmallArrow from '../../components/icons/IconSmallArrow';
  import IconCheck from '../../components/icons/IconCheck';

  import ThumbSlider from '../../components/ThumbSlider';
  import PreFooter from '../../components/PreFooter';
  import RoomDescription from '../../components/RoomDescription';
  import RoomMap from '../../components/RoomMap';
  import ScheduleWithCalendar from '../../components/ScheduleWithCalendar';

  import { getRoom, getSeoBySlug } from '../../service/deliroom-service';

  export default {
    name: 'RoomPage',
    components: {
      ScheduleWithCalendar,
      IconSmallArrow,
      RoomMap,
      RoomDescription,
      PreFooter,
      IconCheck,
      ThumbSlider,
      IconTime,
      IconBurger,
      IconMapPin
    },
    data: () => ({
      activeScrollSection: 'schedule',
      noChangeActiveOnScroll: false,
    }),

    asyncData: async ({ params, redirect, store, req }) => {
      let isMobile = null;

      if (req) {
        isMobile = /Mobile|webOS|BlackBerry|IEMobile|MeeGo|mini|Fennec|Windows Phone|Android|iP(ad|od|hone)/i.test(req.headers['user-agent'])
      } else {
        isMobile = store.state.isMobile
      }

      const room = await getRoom(params.id);
      const description = [];

      if (!room) {
        redirect('/404');
        return;
      }

      // формируем необходимый массив данных для блока "Описание"
      if (room.type) description.push({ label: 'Тип помещения', value: room.type.name });
      if (room.address) description.push({ label: 'Адрес', value: room.address });
      if (room.floor) description.push({ label: 'Этаж', value: room.floor });
      if (room.metro_stations.length) description.push({ label: 'Станция метро', value: room.metro_stations.map((station) => station.name).join(', ') });
      if (room.capacity) description.push({ label: 'Вместимость', value: `до ${room.capacity} человек` });
      if (room.area) description.push({ label: 'Площадь', value: `${room.area} м<sup>2</sup>` });

      return {
        meta: await getSeoBySlug(`/places/${params.id}`),
        isMobileSSR: isMobile,
        room,
        description
      }
    },

    validate({ params }) {
      return /^\d+$/.test(params.id)
    },

    watch: {
      isMobile(val) {
        this.isMobileSSR = val;
      },
    },

    computed: {
      ...mapGetters({
        isAuthenticated: 'auth/isAuthenticated'
      }),

      wrappedRoomName() {
        const symbolCount = this.isMobileSSR ? 16 : 13;
        const words = this.room.name.split(' ');
        let result = '';

        words.forEach((word, index) => {
          if (word.length < symbolCount) {
            result = `${result} ${word}`;

            return;
          }

          const excessLetters = index === 0
            ? (result.length + word.length) % symbolCount
            : symbolCount - (result.length + word.length) % symbolCount;

          if (excessLetters) {
            word = index === 0
              ? word.replace(new RegExp(`([А-ЯЁа-яё]+)([А-ЯЁа-яё]{${excessLetters > 2 ? excessLetters : 3}})`), '$1-$2')
              : word.replace(new RegExp(`([А-ЯЁа-яё]{${excessLetters}})([А-ЯЁа-яё]+)`), '$1-$2')
          }

          result = `${result} ${word}`
        });

        return result;
      },

      isMobile() {
        return this.$store.state.isMobile;
      },

      bookingItems() {
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.room.id)[0];
        if (!currentBookings) return [];

        return currentBookings.bookingItems.filter((booking) => !booking.ordered);
      },

      bookingsPrice() {
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.room.id)[0];

        if (!currentBookings) return null;

        let price = 0;

        let totalPrice = currentBookings.bookingItems
          .reduce((accumulator, currentValue) => {
            if (!currentValue.ordered)
              return accumulator + currentValue.price;
            else
              return accumulator
          }, price);

        if (totalPrice) {
          return totalPrice;
        }
      }
    },

    mounted() {
      this.onScroll();
      window.addEventListener('scroll', this.onScroll);
      window.addEventListener('scroll', _.debounce(this.scrollEnd, 100, { 'leading': false }))
    },

    beforeDestroy() {
      window.removeEventListener('scroll', this.onScroll)
    },

    methods: {
      onScroll() {
        if (this.noChangeActiveOnScroll) return;

        const sections = [this.$refs.description.$el, this.$refs.schedule.$el, this.$refs.map.$el];

        sections.forEach((item) => {
          const top = this.getOffset(item).top - item.offsetHeight * .4;
          const bottom = top + item.getBoundingClientRect().height;
          const scroll = window.pageYOffset;
          const id = item.id;

          if (scroll > top && scroll < bottom) {
            this.activeScrollSection = id;
          }
        });
      },

      scrollEnd() {
        if (this.noChangeActiveOnScroll) this.noChangeActiveOnScroll = false;
      },

      setActive(needToActivate, forceScroll = false) {
        if (needToActivate === this.activeScrollSection && !this.isMobileSSR && !forceScroll) return;
        if (this.noChangeActiveOnScroll) return;

        this.noChangeActiveOnScroll = true;
        this.activeScrollSection = needToActivate;

        this.scrollToElement(this.$el.querySelector(`#${needToActivate}`));
      },

      mobileToTop() {
        this.scrollToElement(this.$refs.roomNav);
      },

      scrollToElement(element) {
        const globalFZ = parseFloat(window.getComputedStyle(document.querySelector('html')).fontSize);

        const navTopOffset = this.getOffset(element).top;
        const topOffset = this.isMobileSSR ? 80 / 16 * globalFZ : 50 / 16 * globalFZ;
        const needToScrollOffset = -(window.pageYOffset - navTopOffset + topOffset);

        window.scrollBy({top: needToScrollOffset, behavior: 'smooth'});

        // На случай, если нужная секция уже находится в видимой части экрана
        // и скролл не инициируется самостоятельно из scrollBy
        const scrollEvt = new CustomEvent('scroll');
        window.dispatchEvent(scrollEvt);

      },

      getOffset(element) {
        if (!element.getClientRects().length) {
          return {top: 0, left: 0};
        }

        let rect = element.getBoundingClientRect();
        let win = element.ownerDocument.defaultView;

        return ({
          top: rect.top + win.pageYOffset,
          left: rect.left + win.pageXOffset
        });
      },

      addScheduleRow() {
        this.$refs.schedule.addScheduleRow();

        this.setActive('schedule', true);
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .room-page {
    margin-top: rem(30);

    &__mobile-slider {
      @media (max-width: $mobile-width) {
        order: -2;

        margin-bottom: rem(28);
      }
    }

    &__right {
      padding: rem(30) rem(24) rem(40);

      @media (max-width: $mobile-width) {
        order: -1;
      }
    }

    &__breadcrumbs {
      display: flex;
      align-items: center;

      margin-bottom: rem(10);
    }

    &__breadcrumbs-item {
      @include p3;

      & + & {
        margin-left: rem(24);

        &::before {
          content: '/';
          position: absolute;
          left: rem(-14);
          color: rgba($black, .3);
        }
      }

      &:hover {
        color: $black;
      }
    }

    &__title {
      @include h3;

      margin: rem(10) 0 rem(16);
    }

    &__info-wrapper {
      margin: rem(16) 0 rem(24);
      overflow: hidden;
    }

    &__info {
      @include breadcrumbs;

      margin: rem(-5) rem(-10);

      .room-page__info-item {
        margin: rem(5) rem(10);
      }
    }

    &__price {
      @include h5;
      margin: rem(24) 0 rem(30);
    }

    &__book-btn {
      width: 100%;
      height: rem(70);
      margin: rem(30) 0 rem(24);
    }

    &__rules-btn {
      @include bold-black-link;

      display: block;
      margin: rem(24) 0 rem(30);

      color: $dark-gray;
      text-align: center;

      &:hover {
        color: $black;
      }
    }

    &__nav {
      display: flex;
      align-items: center;
      padding: rem(10);

      background: $light-gray;
      border: 1px solid rgba($white, 0.6);
      box-shadow: inset rem(-4) rem(-4) rem(10) $white,
      inset rem(4) rem(4) rem(10) #D5DCE4,
      inset rem(-4) rem(-4) rem(6) rgba($white, 0.25);
      border-radius: rem(50);
    }

    &__nav-item {
      & + & {
        margin-left: rem(8);
      }

      flex: 1 1;
      height: rem(50);

      display: flex;
      align-items: center;
      justify-content: center;

      border-radius: rem(40);
      border: rem(1) solid transparent;

      &:hover {
        .room-page__nav-icon {
          stroke: $green;
        }

        cursor: pointer;
      }

      &.active {
        @include green-btn;
        transition: none;

        .room-page__nav-icon {
          stroke: $white;
        }
      }

    }

    &__badge {
      position: absolute;
      z-index: 2;

      &--popular {
        @include room-card-tag;

        top: rem(16);
        left: rem(16);
      }

      &--confirm {
        top: rem(16);
        right: rem(16);

        height: rem(30);
        width: rem(30);

        display: flex;
        align-items: center;
        justify-content: center;

        background: $white;
        border-radius: 50%;

        svg {
          stroke: $green;
        }
      }
    }

    &__description {
      margin: rem(70) 0;
    }

    &__map {
      margin: rem(70) 0 rem(100);

      @media (max-width: $mobile-width) {
        margin: rem(44) 0 rem(44);
      }
    }
  }
</style>
